﻿// --------------------------------------------------------------------------------------
//
// GeldAutoCS.cs                                                  Ulrich Müller  24.06.07
//                                                                PCS1700 C# 2005 Express
// GeldAutomat nach Profi Computing 1991 Experimentierbuch Seite 58 ff.
// Mit Betragseingabe :         Basis ist die Assembly FishFace2005.DLL
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFace40;

namespace BeispieleFishFace {
  public partial class GeldAutoCS : Form {
    const int mSchieber = 1;
    const int mSchlitten = 2;
    const int eSchieberHinten = 1;
    const int eSchieberVorn = 2;
    const int eSchlittenEnde = 3;
    const int eSchlittenImpuls = 4;

    FishFace ft = new FishFace();

    private void Action() {
      int Z50, Z100, Z200, Betrag;

      lblStatus.Text = "Fahren auf Grundstellung";
      ft.SetMotor(mSchieber, (int)Dir.Right);
      ft.WaitForInput(eSchieberHinten, false);
      ft.SetMotor(mSchieber, (int)Dir.Off);
      ft.SetMotor(mSchlitten, (int)Dir.Left); 
      ft.WaitForInput(eSchlittenEnde, true);
      ft.SetMotor(mSchlitten, (int)Dir.Off);

      Betrag = (int)numBetrag.Value;
      Z200 = 0;
      while (Betrag - 200 >= 0) { Betrag -= 200; Z200++; } ;
      Z100 = 0;
      while (Betrag - 100 >= 0) {Betrag -= 100; Z100++; } ;
      Z50 = 0;
      while (Betrag - 50 >= 0) { Betrag -= 50; Z50++; };

      lblStatus.Text = "Schacht rechts anfahren";
      ft.SetMotor(mSchlitten, (int)Dir.Right);
      ft.WaitForChange(eSchlittenImpuls, 20);
      ft.SetMotor(mSchlitten, (int)Dir.Off);
      Schieber(Z200);

      lblStatus.Text = "Schacht Mitte anfahren";
      ft.SetMotor(mSchlitten, (int)Dir.Right);
      ft.WaitForChange(eSchlittenImpuls, 70);
      ft.SetMotor(mSchlitten, (int)Dir.Off);
      Schieber(Z100);

      lblStatus.Text = "Schacht links anfahren";
      ft.SetMotor(mSchlitten, (int)Dir.Right);
      ft.WaitForChange(eSchlittenImpuls, 70);
      ft.SetMotor(mSchlitten, (int)Dir.Off);
      Schieber(Z50);

      lblStatus.Text = "FINIS";
    }
    private void Schieber(int Anz) {
      lblStatus.Text = "Münzausgabe";
      for (int i = 1; i <= Anz; i++) {
        ft.SetMotor(mSchieber, (int)Dir.Left);
        ft.WaitForInput(eSchieberVorn, true);
        ft.SetMotor(mSchieber, (int)Dir.Right);
        ft.WaitForInput(eSchieberHinten, false);
        ft.SetMotor(mSchieber, (int)Dir.Off);
      }
    }

    #region --- Programm-Kontrolle ---
    public GeldAutoCS() {
      InitializeComponent();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      // --- Open erstes ROBO an USB oder Intelligent Interface an COM
      //     während des Ablaufs von Action() gesperrt ---------------
      try {
        if (cboPortName.SelectedIndex == 0)
          ft.OpenInterface(IFTypen.ftROBO_first_USB, 0);
        else ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5);
        cmdAction.Enabled = false;
        cmdEnde.Text = "&HALT";
        lblStatus.Text = "--- Bei der Arbeit ---";
        lblHinweis.Text = "--- Ende : HALT-Button oder ESC-Taste ---";

        Action();        // --- Haupt-Routine der Anwendung

        ft.ClearMotors();
      }
      catch (FishFaceException eft) {
        MessageBox.Show(eft.Message, this.Text,
          MessageBoxButtons.OK, MessageBoxIcon.Stop);
      }
      finally {
        ft.CloseInterface();
        cmdAction.Enabled = true;
        cmdEnde.Text = "&ENDE";
        lblStatus.Text = "--- Auf ein Neues ---";
        lblHinweis.Text = "Nochmal : ACTION, sonst ENDE oder ESC-Taste";
        cmdAction.Focus();
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      // --- Programmende nur, wenn Action nicht läuft ---
      if (cmdEnde.Text == "&HALT") ft.NotHalt = true; else this.Close();
    }

    private void formLoad(object sender, EventArgs e) {
      // --- Default-Interface : Erstes ROBO Interface an USB ----
      cboPortName.SelectedIndex = 0;
    }

    private void formClosing(object sender, FormClosingEventArgs e) {
      // --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ------
      if (cmdEnde.Text == "&HALT") e.Cancel = true;
    }
    #endregion
  }
}